<?php
/**
* CROSS SERVER CHAT CLIENT BETA
* plugin.xserver_client.php
* by Reaby
* 
*/
Aseco::registerEvent('onStartup',         'xChat_start');
Aseco::registerEvent('onChat',         'xChat_chat');
Aseco::registerEvent('onPlayerConnect',         'xChat_connect');
Aseco::registerEvent('onPlayerDisconnect',         'xChat_disconnect');
Aseco::registerEvent('onPlayerManialinkPageAnswer', 'xChat_events');
Aseco::addChatCommand('pmx','Whisper to a friend over server');
Aseco::addChatCommand('xlink','Show players on other servers');
Aseco::registerEvent("onEcho", "xChat_echo");


function xChat_start($aseco, $command) {
global $xsettings;
$xsettings = array();
$xml_parser = new Examsly();

if ($settings = $xml_parser->parseXml('xserver_chat.xml')) {
      $xsettings['server_login'] = $settings['SETTINGS']['TM_SERVERLOGIN'][0];
   	  $xsettings['xchat_server'] = $settings['SETTINGS']['XCHAT_SERVER'][0];
	  $xsettings['xchat_port'] = $settings['SETTINGS']['XCHAT_PORT'][0];
	  $xsettings['xchat_pass'] = $settings['SETTINGS']['XCHAT_PASSWORD'][0];
	  } else {
      // could not parse XML file
      trigger_error('[CrossServer Chat] Could not read/parse setttings file xserver_chat.xml!', E_USER_WARNING);
      return false;
   }	
   

}

function xChat_events($aseco, $answer) {
	/// $answer[0]=PlayerUid, $answer[1]=Login, $answer[2]=Answer
	global $xsettings;
	if ($answer[2] >= 70001 && $answer[2] <= 70200) {
		// get player
		$player = $aseco->server->players->getPlayer($answer[1]);
		$target = $player->playerlist[$answer[2]-70001]['login'];
		$login = $answer[1];
		mainwindow_off($aseco, $player->login);
		//send query to target server
		$array = array("fromlogin" => $login, "fromserver" => $xsettings['server_login'], "toserver" => $target);
		xChat_sendmsg('request','playerlist',$array);
	
	}
}  // xChat_events



function xChat_echo($aseco, $args) {
    $internal = $args[0];
	$data = unserialize($args[1]);
	if ($internal == "Xchat_linked_servers") {
	
	$player = $aseco->server->players->getPlayer($data['fromlogin']);

	$player->playerlist = array();
			$player = $aseco->server->players->getPlayer($data['fromlogin']);
				
		$login = $player->login;
		// use only first parameter
			$player->playerlist = array();
			$head = 'Show Linked Servers'; 
			
			
		
				$msg = array();
				$msg[] = array('Id', 'Server name', '');
				$pid = 1;
				$lines = 0;
				$player->msgs = array();
				$player->msgs[0] = array(1, $head, array(1.3, 0.1, 0.9, 0.3), array('Icons128x128_1', 'Buddies'));
				foreach ($data['servers'] as $pl) {
						$plarr = array();
						$plarr['login'] = $pl['login'];
						$player->playerlist[] = $plarr;

						// format nickname & login
						//$serverlogin = $pl['servername'];
						$ply = $pl['servername'];
						// if points are not set, default to 0		
						
						// add clickable button
						if ($aseco->settings['clickable_lists'] && $pid <= 200)
							$ply = array($ply, $pid+70000);  // action id

						$msg[] = array(str_pad($pid, 2, '0', STR_PAD_LEFT) . '.', $ply);
						$pid++;
						$lines++;
						if ($lines > 14) {
							$player->msgs[] = $msg;
							$lines = 0;
							$msg = array();
							$msg[] = array('Id', 'Nick', '');
						}
					
				}
				// add if last batch exists
				if (count($msg) > 1)
					$player->msgs[] = $msg;

				// display ManiaLink message
				if (count($player->msgs) > 1) {
					display_manialink_multi($player);
				} else {  // == 1
					$message = "[CrossServerChat] Manialink Error";
					$aseco->client->query('ChatSendServerMessageToLogin', $message , $player->login);
				}
	
	}
	
	
	if ($internal == "Xchat_Playerlist") {
		$player = $aseco->server->players->getPlayer($data['fromlogin']);
			
			$player->playerlist = array();
			$head = 'Users on external server';
			$msg = array();
			$msg[] = array('Nick', 'Login');
			$pid = 1;
			$lines = 0;
			$player->msgs = array();
			$player->msgs[0] = array(1, $head, array(1.2, 0.9, 0.3), array('Icons128x128_1', 'Buddies'));
			// create list of players, optionally by (sub)string
				foreach ($data['players'] as $pl) 
				{
				//print_r($pl);
				$llogin = $pl['login'];
				$nick = $pl['nickname'];	
				$msg[] = array($nick,$llogin);
					$pid++;
					$lines++;
					if ($lines > 14) {
						$player->msgs[] = $msg;
						$lines = 0;
						$msg = array();
						$msg[] = array('Nick', 'Login');
					}
				}

				
			// add if last batch exists
			if (count($msg) > 1)
				$player->msgs[] = $msg;

			// display ManiaLink message
			if (count($player->msgs) > 1) {
				display_manialink_multi($player);
			} else {  // == 1
				$aseco->client->query('ChatSendServerMessageToLogin', $aseco->formatColors('{#server}> {#error}Ei pisteita'), $player->login);
			}
		} //end of if
}


function chat_xlink($aseco, $command) {
	global $xsettings;
	$player = $command['author'];
	$login = $player->login;
	$array = array("fromlogin" => $login, "fromserver" => $xsettings['server_login']);
	xChat_sendmsg('request','linked_servers',$array);
}

function chat_pmx($aseco, $command) {
	global $xsettings;
	$player = $command['author'];
	$nickname = $player->nickname;
	$target = explode(' ', $command['params']);
	for ($x=1; $x < count($target); $x++) {
	$message .= $target[$x]." ";
	}
	$array = array("fromnick" => $nickname, "tologin" => $target[0] , "message" => $message);
	$localout = '$f0f You whisper to '.$target[0].": ".$message;
	$aseco->client->query('ChatSendServerMessageToLogin',$localout , $player->login);
	xChat_sendmsg('chat','ChatPrivate',$array);

}


function xChat_connect($aseco, $player) {
	global $xsettings;
	$message = '$0f0 Connection: ' .$player->nickname. '$n$z$s$0f0 from ' . $aseco->server->nickname;
	$array	= array("server_login" => $xsettings['server_login'], "message" => $message);
	xChat_sendmsg('chat','PlayerConnect',$array);
}

function xChat_disconnect($aseco, $player) {
	global $xsettings;
	$message = '$0f0 Disconnect: ' .$player->nickname. '$n$z$s$0f0 from ' . $aseco->server->nickname;
	$array	= array("server_login" => $xsettings['server_login'], "message" => $message);
	xChat_sendmsg('chat','PlayerDisconnect',$array);
}


function xChat_chat($aseco, $command)
   {
   global $xsettings;
   $login = $command[1];
   $player = $aseco->server->players->getPlayer($login);
   $nick = $player->nickname;
   $chat = $command[2];
   if ( $command[0] != $aseco->server->login)  // check if chat text is really from player, not from server.
      {
      if (substr($chat, 0, 1) != '/' )  // check is command is ment to be server releated
         {
   xChat_sendmsg('chat', 'ChatPublic', array("server_login" => $xsettings['server_login'], "message" => $chat, "color" => $color, "nickname" => $nick));
         }
    }   
}

function xChat_sendmsg($commandtype,$subtype,$array) {
global $xsettings;
$address = $xsettings['xchat_server'];
$port = $xsettings['xchat_port'];
$password = $xsettings['xchat_pass'];
if (($sock = socket_create(AF_INET, SOCK_STREAM, SOL_TCP)) === false) {
   return false;
}

if (socket_connect($sock, $address, $port) === false) {
    return false;
}
$outarray = serialize($array);
  usleep(100);
  $message = $commandtype."\t".$subtype."\t".$outarray."\t".$password."\n";
  socket_write($sock,$message);
  usleep(100);
  socket_shutdown($sock, 0);//close reading
  socket_close($sock);//free resource
}
?>